;          RGB/YUV conversions using the FPU

; #########################################################################

      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################

      include \masm32\include\windows.inc

      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc

      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib

      RGB2YUV PROTO :DWORD,:DWORD
      YUV2RGB PROTO :DWORD

YUV STRUCT
   Y  DD  ?
   U  DD  ?
   V  DD  ?
YUV ENDS

.data

   n114  dd  0.114
   n299  dd  0.299
   n492  dd  0.492
   n587  dd  0.587
   n877  dd  0.877
   myRGB    dd    00c08040h
   myYUV    YUV <>
   txtbuf   db    20 dup(?)

.code

start:
      mov   ecx,100
   @@:
      push  ecx
      invoke RGB2YUV,myRGB,ADDR myYUV
      invoke YUV2RGB,ADDR myYUV
      mov   myRGB,eax
      pop   ecx
      dec   ecx
      jnz   @B

      mov   ecx,8
      lea   edi,txtbuf
      mov   eax,myRGB
   @@:
      rol   eax,4
      push  eax
      and   al,0fh
      add   al,30h
      .if   al > "9"
            add   al,7
      .endif
      stosb
      pop   eax
      dec   ecx
      jnz   @B
      invoke MessageBox,0,ADDR txtbuf,0,MB_OK
      invoke ExitProcess,0

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

RGB2YUV proc USES esi clrRGB:DWORD, pYUV:DWORD

LOCAL RED    :DWORD
LOCAL GREEN  :DWORD
LOCAL BLUE   :DWORD

   mov  esi,pYUV

;compute Y = 0.299 R + 0.587 G + 0.114 B

   finit
   mov  eax,clrRGB
   and  eax,0FFh   ;isolate the RED
   mov  RED,eax
   fild RED
   fmul n299

   mov  eax,clrRGB
   shr  eax,8
   and  eax,0FFh   ;isolate the GREEN
   mov  GREEN,eax
   fild GREEN
   fmul n587
   fadd

   mov  eax,clrRGB
   shr  eax,16
   and  eax,0FFh   ;isolate the BLUE
   mov  BLUE,eax
   fild BLUE
   fmul n114
   fadd           ;st(0)=Y

;compute U = 0.492 (B - Y)

   fild BLUE
   fsub st,st(1)   ;(B - Y)
   fmul n492
   fstp dword ptr[esi+4]

;compute V = 0.877 (R - Y)

   fild RED
   fsub st,st(1)   ;(R - Y)
   fmul n877
   fstp dword ptr[esi+8]
   fstp dword ptr[esi]
   ret
RGB2YUV endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

YUV2RGB proc USES esi pYUV:DWORD

LOCAL RED   :DWORD
LOCAL GREEN :DWORD
LOCAL BLUE  :DWORD

   mov esi,pYUV

; RED (R = (V/0.877+Y))

   finit
   fld  dword ptr[esi+8]
   fdiv n877
   fadd dword ptr[esi]
   fistp RED
   test RED,80000000h   ;test if negative
   jz   @F
   mov  RED,0
@@:
   cmp  RED,255         ;check for overflow
   jbe  @F
   mov  RED,255
@@:

; BLUE (B = (U/0.492+Y))
   fld  dword ptr[esi+4]
   fdiv n492
   fadd dword ptr[esi]
   fistp BLUE
   test BLUE,80000000h   ;test if negative
   jz   @F
   mov  BLUE,0
@@:
   cmp  BLUE,255         ;check for overflow
   jbe  @F
   mov  BLUE,255
@@:

; GREEN (G = (Y-(0.299R + 0.114B))/0.587)
   fild RED
   fmul n299
   fild BLUE
   fmul n114
   fadd
   fsubr dword ptr[esi]
   fdiv n587
   fistp GREEN
   test GREEN,80000000h   ;test if negative
   jz   @F
   mov  GREEN,0
@@:
   cmp  GREEN,255         ;check for overflow
   jbe  @F
   mov  GREEN,255
@@:

   mov  eax,BLUE
   shl  eax,8
   add  eax,GREEN
   shl  eax,8
   add  eax,RED
   ret
YUV2RGB endp

end start
